// Next.js API route support: https://nextjs.org/docs/api-routes/introduction
import type {NextApiRequest, NextApiResponse} from "next";
import client from "@/lib/mongodb";
import {withIronSessionApiRoute} from "iron-session/next";
import {sessionOptions} from "@/lib/session";
import {flatten} from "lodash";
import {Exam} from "@/interfaces/exam";
import {MODULE_ARRAY} from "@/utils/moduleUtils";

const db = client.db(process.env.MONGODB_DB);

export default withIronSessionApiRoute(handler, sessionOptions);

async function handler(req: NextApiRequest, res: NextApiResponse) {
	if (req.method === "GET") return await GET(req, res);

	res.status(404).json({ok: false});
}

async function GET(req: NextApiRequest, res: NextApiResponse) {
	if (!req.session.user) {
		res.status(401).json({ok: false});
		return;
	}

	const moduleExamsPromises = MODULE_ARRAY.map(async (module) => {
		const snapshot = await db.collection(module).find<Exam>({ isDiagnostic: false }).toArray();

		return snapshot.map((doc) => ({
			...doc,
			module,
		}));
	});

	const moduleExams = await Promise.all(moduleExamsPromises);
	res.status(200).json(flatten(moduleExams));
}
